import java.net.URL;
import java.sql.*;
import intersoft.jdbc.*;

public 
class ConsulExec {

public String res = new String();

public String port;
public String host;
public String user;
public String passw;


public  
ConsulExec(String port_, String host_, String user_, String passw_)
{
System.err.println("__TRACE__ ConsulExec: 19 Constructing ...");
	port = new String(port_);
	host = new String(host_);
	user = new String(user_);
	if (passw_ == null)
		passw = new String("");	
	else
		passw = new String(passw_);	

}



public  
int 
execute(String schema_, String query_)
{

	String portNum = port;
	String hostName = host;
	String userName = user;
	String passwd = passw;

	String url = new String("jdbc:essentia://" + hostName + ":" + portNum);

	try {

			// Degug messages
			DriverManager.setLogStream(System.err);



	java.util.Properties info = System.getProperties();
	info.put("user", userName);
	info.put("password", passw);
	info.put("jdbc.drivers", "intersoft.jdbc.EssentiaDriver");
			
			con = DriverManager.getConnection (url, userName, passwd);

			// Statement
			stmt = con.createStatement ();
			int r = stmt.executeUpdate (schema_);

			// Statement
			rs = stmt.executeQuery(query_);

/*
			// PreparedStatement
			pstmt = con.prepareStatement(query_);
			pstmt.setString(1, "Aldusa S.A.");
			rs = pstmt.executeQuery();
*/

			rsmd = rs.getMetaData();
			ncols = getNcols();  			
		}
		catch (SQLException ex) {

			// A SQLException was generated.  Catch it and
			// display the error information.  Note that there
			// could be multiple error objects chained
			// together

			System.out.println ("\n*** SQLException caught ***\n");

			while (ex != null) {
				System.out.println ("SQLState: " +
					ex.getSQLState ());
				System.out.println ("Message:  " +
					ex.getMessage ());
				System.out.println ("Vendor:   " +
					ex.getErrorCode ());
				ex = ex.getNextException ();
				System.out.println ("");
			}
		}
		catch (java.lang.Exception ex) {

			// Got some other type of exception.  Dump it.

			ex.printStackTrace ();
		}      
		return ncols;
}

public
void
close()
{
	try {
			rs.close();
 			stmt.close();
			con.close();
	} catch (SQLException ex) {
			System.out.println ("\n*** SQLException caught ***\n");

			while (ex != null) {
				System.out.println ("SQLState: " +
					ex.getSQLState ());
				System.out.println ("Message:  " +
					ex.getMessage ());
				System.out.println ("Vendor:   " +
					ex.getErrorCode ());
				ex = ex.getNextException ();
				System.out.println ("");
			}
		} catch (java.lang.Exception ex) {

			ex.printStackTrace ();
		}      

}

//-------------------------------------------------------------------
// checkForWarning
// Checks for and displays warnings.  Returns true if a warning
// existed
//-------------------------------------------------------------------


private static 
boolean 
checkForWarning (SQLWarning warn)
throws SQLException
{
		boolean rc = false;

		// If a SQLWarning object was given, display the
		// warning messages.  Note that there could be
		// multiple warnings chained together

		if (warn != null) {
			System.out.println ("\n *** Warning ***\n");
			rc = true;
			while (warn != null) {
				System.out.println ("SQLState: " +
					warn.getSQLState ());
				System.out.println ("Message:  " +
					warn.getMessage ());
				System.out.println ("Vendor:   " +
					warn.getErrorCode ());
				System.out.println ("");
				warn = warn.getNextWarning ();
			}
		}
		return rc;
}

	//-------------------------------------------------------------------
	// dispResultSet
	// Displays all columns and rows in the given result set
	//-------------------------------------------------------------------

public  
String 
dispResultSet ()
//throws SQLException
{
        String aux = new String();	
		int i;
		int tp;
	try {
		boolean more = rs.next ();
		
		while (more) {
			// Loop through each column, getting the
			// column data and displaying
			for (i=1; i<=ncols; i++) {
				if (i > 1) aux += "|";
//				tp = rsmd.getColumnType(i);
				aux +=  rs.getString(i);
/*
				switch (tp) {
					case Type._STRING:
					{
						aux +=  rs.getString(i);
						break;
					}
					case Type._NUMERIC:
					{
						aux += rs.getNumeric(i, 3);
						break;
					}
					case Type._DATE:
					{
						aux += rs.getDate(i);
						break;
					}
					case Type._TIME:
					{
						aux += rs.getTime(i);
						break;
					}
					default:
						break;
				}
*/
			}
			
			aux += "\n";
			// Fetch the next result set row
			more = rs.next ();
			nrows++;
		} 

	} catch (SQLException ex) {

		System.out.println ("\n*** SQLException caught ***\n");

		while (ex != null) {
			System.out.println ("SQLState: " +
				ex.getSQLState ());
			System.out.println ("Message:  " +
				ex.getMessage ());
			System.out.println ("Vendor:   " +
				ex.getErrorCode ());
				ex = ex.getNextException ();
			System.out.println ("");
		}
	}


	return aux;
}   

public  
String 
getHeaders ()
//throws SQLException
{
	int i;
	String hdr = new String();

	try {
			
		for (i=1; i<=ncols; i++) {
			if (i > 1) hdr += "|";
			hdr += rsmd.getColumnName(i);
		}
	} catch (SQLException ex) {

		System.out.println ("\n*** SQLException caught ***\n");

		while (ex != null) {
			System.out.println ("SQLState: " +
				ex.getSQLState ());
			System.out.println ("Message:  " +
				ex.getMessage ());
			System.out.println ("Vendor:   " +
				ex.getErrorCode ());
				ex = ex.getNextException ();
			System.out.println ("");
		}
	}

	return hdr;		
}

private
int 
getNcols()
{
	int nc = 0;
	try {
		nc = rsmd.getColumnCount();
	} catch (SQLException ex) {

		System.out.println ("\n*** SQLException caught ***\n");

		while (ex != null) {
			System.out.println ("SQLState: " +
				ex.getSQLState ());
			System.out.println ("Message:  " +
				ex.getMessage ());
			System.out.println ("Vendor:   " +
				ex.getErrorCode ());
				ex = ex.getNextException ();
			System.out.println ("");
		}
	}
	
	return nc;
}

public
int
getNrows()
{
	return nrows;
}

private int ncols = 0;
private int nrows = 0;
private ResultSet rs;
private ResultSetMetaData rsmd;
private Connection con;
private Statement stmt;
private PreparedStatement pstmt;
}








